function loadIframes(wrapper)
{
    // Restore the original iframe codes
    var iframesHtml = wrapper.dataset.originalHtml;
    if(iframesHtml !== undefined)
    {
        wrapper.innerHTML = iframesHtml;

        // Set consent flag for this embed
        wrapper.dataset.consentGiven = 'true';
    }
}

function checkWrappers(embedWrappers)
{
    embedWrappers.forEach(function(wrapper)
    {
        var consent = localStorage.getItem('privacyConsent-' + wrapper.dataset.service);
        if (consent === 'agreed')
        {
            // Load the iframe for this embed
            loadIframes(wrapper);
        }
    });
}

// Check if the user has agreed to the privacy policy for each service
window.addEventListener('DOMContentLoaded', function()
{
    var embedWrappers = document.querySelectorAll('.embedWrapper');
    embedWrappers.forEach(function(wrapper)
    {
        var consent = localStorage.getItem('privacyConsent-' + wrapper.dataset.service);

        if (consent !== 'agreed')
        {
            // If user has not yet agreed, replace the iframe with the consent message and the agree button
            wrapper.dataset.originalHtml = wrapper.innerHTML;

            wrapper.innerHTML = '';
            var consentText = document.getElementById('embedPrivacyConsent');
            var consentMessage = `<div class="embedPlaceholder">
                                    <h2>${wrapper.dataset.service}</h2>
                                    <p>${consentText.dataset.privacytext}
                                        <a href="${wrapper.dataset.privacylink}" target="_blank">${consentText.dataset.privacylabel}</a>
                                    </p>
                                    <button class="loadIframeConsent">${consentText.dataset.buttonlabel}</button>
                                </div>`;
            wrapper.insertAdjacentHTML('beforeend', consentMessage);
           
            // Add event listener for the consent button
            var consentButton = wrapper.querySelector('.loadIframeConsent');
            consentButton.addEventListener('click', function()
            {
                // Store the consent in browser storage for this service
                localStorage.setItem('privacyConsent-' + wrapper.dataset.service, 'agreed');

                // Load the iframe for this service
                checkWrappers(embedWrappers);
            });
        }
    });
});